//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// ServerListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ServerListCtrl.h"

// CServerListCtrl

IMPLEMENT_DYNAMIC(CServerListCtrl, CTreeCtrl)
CServerListCtrl::CServerListCtrl(){
	memset(&asc_sort,0,8);
}

bool CServerListCtrl::Init(CServerList* in_list){ 

   this->ModifyStyle(0,TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS); 
   // Set Imagelist 
   server_list = in_list; 
   imagelist.Create(16,16,ILC_COLOR,0,10); 
   imagelist.SetBkColor(RGB(255,255,255)); 
   imagelist.Add(theApp.LoadIcon(IDI_ICON1)); 

   this->SetImageList(&imagelist,LVSIL_SMALL);//TVSIL_NORMAL); 
   this->ModifyStyle(LVS_SINGLESEL|LVS_LIST|LVS_ICON|LVS_SMALLICON,LVS_REPORT); //here the CListCtrl is set to report-style 

   InsertColumn(0,"Server Name",LVCFMT_LEFT,theApp.glob_prefs->GetServerColumnWidth(0) ); 
   InsertColumn(1,"IP",LVCFMT_LEFT,theApp.glob_prefs->GetServerColumnWidth(1)); 
   InsertColumn(2,"Description",LVCFMT_LEFT,theApp.glob_prefs->GetServerColumnWidth(2)); 
   InsertColumn(3,"Ping",LVCFMT_LEFT,theApp.glob_prefs->GetServerColumnWidth(3)); 
   InsertColumn(4,"Users",LVCFMT_LEFT,theApp.glob_prefs->GetServerColumnWidth(4)); 
   InsertColumn(5,"Files",LVCFMT_LEFT,theApp.glob_prefs->GetServerColumnWidth(5)); 
   InsertColumn(6,"Preference",LVCFMT_LEFT,theApp.glob_prefs->GetServerColumnWidth(6));
   InsertColumn(7,"Failed",LVCFMT_LEFT,theApp.glob_prefs->GetServerColumnWidth(7));

   return true; 
} 

CServerListCtrl::~CServerListCtrl() {
}

/*void CServerListCtrl::ShowServers(){ 
   DeleteAllItems(); 
   int i=0; 
   CString temp; 
   for(POSITION pos = server_list->list->GetHeadPosition(); pos != NULL;server_list->list->GetNext(pos)) { 
      CServer* cur_server = server_list->list->GetAt(pos); 
      InsertItem(LVIF_TEXT|LVIF_PARAM,i,cur_server->GetListName(),0,0,0,(LPARAM)cur_server);
	  RefreshServer( cur_server );
      i++; 
   } 
}
*/

void CServerListCtrl::RemoveServer(CServer* todel,bool bDelToList){
	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)todel;
	sint32 result = FindItem(&find);
	if (result != (-1) ){
	server_list->RemoveServer((CServer*)GetItemData(result));
	DeleteItem(result); 
	}
	return;
}

// Remove Dead Servers
void CServerListCtrl::RemoveDeadServer(){
	if( theApp.glob_prefs->DeadServer() == 1 )
		return;
	for(POSITION pos = server_list->list->GetHeadPosition(); pos != NULL;server_list->list->GetNext(pos)) { 
		CServer* cur_server = server_list->list->GetAt(pos); 
		if( cur_server->GetFailedCount() >= theApp.glob_prefs->GetDeadserverRetries() ){	// MAX_SERVERFAILCOUNT 
			RemoveServer( cur_server, true );
			pos = server_list->list->GetHeadPosition();
		}
	}
}

bool CServerListCtrl::AddServer(CServer* toadd,bool bAddToList, bool pingserver){ 
   if (!server_list->AddServer(toadd,pingserver)) 
      return false; 
   if (bAddToList) 
   {
	   uint32 itemnr = GetItemCount();
	   InsertItem(LVIF_TEXT|LVIF_PARAM,itemnr,toadd->GetListName(),0,0,1,(LPARAM)toadd);
	   RefreshServer( toadd );
   } 
   return true; 
}


void CServerListCtrl::RefreshServer( CServer* server ){

	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)server;
	sint32 itemnr = FindItem(&find);
	if (itemnr == (-1))
		return;
	CString temp;
	temp.Format( "%s : %i",server->GetAddress(),server->GetPort());
	SetItemText(itemnr,1,(LPCTSTR)temp);
	if(server->GetDescription()){
		temp.Format( server->GetDescription());
		SetItemText(itemnr,2,(LPCTSTR)temp);
	}
	if(server->GetPing()){
		temp.Format( "%i",server->GetPing()); 
		SetItemText(itemnr,3,(LPCTSTR)temp);
	}
	if(server->GetUsers()){
		temp.Format( "%i",server->GetUsers()); 
		SetItemText(itemnr,4,(LPCTSTR)temp);
	}
	if(server->GetFiles()){
		temp.Format( "%i",server->GetFiles()); 
		SetItemText(itemnr,5,(LPCTSTR)temp);
	}
	if(server->GetPreferences()){
		temp.Format( "%i",server->GetPreferences()); 
		SetItemText(itemnr,6,(LPCTSTR)temp);
	}
	if( server->GetFailedCount() < 0 )
		server->ResetFailedCount();
	temp.Format( "%i",server->GetFailedCount()); 
	SetItemText(itemnr,7,(LPCTSTR)temp);
}

BEGIN_MESSAGE_MAP(CServerListCtrl, CListCtrl/*CTreeCtrl*/) 
   ON_NOTIFY_REFLECT(NM_RCLICK, OnNMRclickServlist) 
   ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnLvnColumnclickServlist) 
   ON_NOTIFY_REFLECT (NM_DBLCLK, OnNMLdblclk) //<-- mod bb 27.09.02 
END_MESSAGE_MAP()

// CServerListCtrl message handlers

void CServerListCtrl::OnNMRclickServlist(NMHDR *pNMHDR, LRESULT *pResult) 
{ 
   POINT point; 
   ::GetCursorPos(&point); 

   // tecxx 0609 2002 
   // fix - on right click, we also want to change the current selection like the left click does 
   CPoint p = point; 
   ScreenToClient(&p); 
   int it = HitTest(p); 
   if (it != -1) 
      SetSelectionMark(it);   // display selection mark correctly! 
   // fix end 

   // Create up-to-date popupmenu
   UINT flags;
   CTitleMenu m_ServerMenu;
	
	// set state of selection-dependent menuitems
	flags=MF_STRING || MF_DISABLED;
	if (this->GetSelectionMark() != -1) if (((CServer*)GetItemData(GetSelectionMark())) != NULL) flags=MF_STRING;

   m_ServerMenu.CreatePopupMenu(); 
   m_ServerMenu.AddMenuTitle("Server");
   m_ServerMenu.AppendMenu(flags,MP_CONNECTTO, (LPCTSTR)"Connect to this Server"); 
   m_ServerMenu.AppendMenu(flags,MP_REMOVE,   (LPCTSTR)"Remove this Server"); 
   m_ServerMenu.AppendMenu(MF_STRING,MP_REMOVEALL, (LPCTSTR)"Remove all Servers"); 

   m_ServerMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this); 

   m_ServerMenu.DestroyMenu();

   *pResult = 0; 
}

BOOL CServerListCtrl::OnCommand(WPARAM wParam,LPARAM lParam ){ 
   int item= this->GetSelectionMark(); 

   if (wParam==MP_REMOVEALL)
   { 
       theApp.downloadqueue->StopUDPRequests(); 
       ShowWindow(SW_HIDE); 
       server_list->RemoveAllServers(); 
       DeleteAllItems(); 
       ShowWindow(SW_SHOW); 
       return true;
   } 

   if (item != -1){ 
      if (((CServer*)GetItemData(GetSelectionMark())) != NULL){ 

		  switch (wParam){ 
            case MP_CONNECTTO: 
               theApp.serverconnect->ConnectToServer((CServer*)GetItemData(GetSelectionMark())); 
               break; 
            case MP_REMOVE: 
            { 
               server_list->RemoveServer((CServer*)GetItemData(GetSelectionMark())); 
               DeleteItem(item); 
               break; 
            } 
         } 
      } 
   } 
   return true; 
}
void CServerListCtrl::OnNMLdblclk(NMHDR *pNMHDR, LRESULT *pResult){ // mod bb 27.09.02
	if (GetSelectionMark() != (-1))
		theApp.serverconnect->ConnectToServer((CServer*)GetItemData(GetSelectionMark())); 
}

bool CServerListCtrl::AddServermetToList(CString strFile) 
{ 
   bool flag=server_list->AddServermetToList(strFile);
   RemoveDeadServer();
   return flag;
}

void CServerListCtrl::OnLvnColumnclickServlist(NMHDR *pNMHDR, LRESULT *pResult) 
{ 
   NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR; 
   // if it's a second click on the same column then reverse the sort order, 
   // otherwise sort the new column in ascending order. 
   asc_sort[pNMListView->iSubItem] = !asc_sort[pNMListView->iSubItem]; 
   SortItems(&SortProc,pNMListView->iSubItem+ ((asc_sort[pNMListView->iSubItem])? 0:10)); 
   this->Invalidate(); 
   *pResult = 0; 
} 

int CServerListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){ 
   CServer* item1 = (CServer*)lParam1; 
   CServer* item2 = (CServer*)lParam2; 
   if((item1 == NULL) || (item2 == NULL)) return 0; 
   int iTemp=0; 
   int counter1; 
   int counter2; 
    
   switch(lParamSort){ 
      case 0: //(List) Server-name asc 
         return strcmp(item1->GetListName(),item2->GetListName()); 
      case 10: //(List) Server-name desc 
         return strcmp(item2->GetListName(),item1->GetListName()); 
      case 1:{ //IP asc 
         CString sIP1, sIP2, sTemp1, sTemp2; 
         counter1 = counter2 = iTemp = 0; 
         sIP1 = item2->GetFullIP(); 
         sIP2 = item1->GetFullIP(); 
         for(int i=0; iTemp == 0 ; i++){ 
            sTemp1 = sIP1.Tokenize(".",counter1); 
            sTemp2 = sIP2.Tokenize(".",counter2); 
            iTemp = atoi(sTemp2) - atoi(sTemp1); 
            if(i>2){ 
               return item1->GetPort() - item2->GetPort(); 
            } 
         } 
         return iTemp; 
      } 
      case 11:{ //IP desc 
         CString s2IP1, s2IP2, s2Temp1, s2Temp2; 
         counter1 = counter2 = iTemp = 0; 
         s2IP1 = item2->GetFullIP(); 
         s2IP2 = item1->GetFullIP(); 
         for(int i=0; iTemp == 0 ; i++){ 
            s2Temp1 = s2IP1.Tokenize(".",counter1); 
            s2Temp2 = s2IP2.Tokenize(".",counter2); 
            iTemp = atoi(s2Temp1) - atoi(s2Temp2); 
            if(i>2){ 
               return item2->GetPort() - item1->GetPort(); 
            } 
         } 
         return iTemp; 
      } 
      case 2: //Description asc 
         if((item1->GetDescription() != NULL) && (item2->GetDescription() != NULL)) 
            //the 'if' is necessary, because the Description-String is not 
            //always initialisized in server.cpp 
            return strcmp(item2->GetDescription(),item1->GetDescription()); 
         return 0; 
      case 12: //Desciption desc 
         if((item1->GetDescription() != NULL) && (item2->GetDescription() != NULL)) 
            return strcmp(item1->GetDescription(),item2->GetDescription()); 
         return 0; 
      case 3: //Ping asc 
         return item2->GetPing() - item1->GetPing(); 
      case 13: //Ping desc 
         return item1->GetPing() - item2->GetPing(); 
      case 4: //Users asc 
         return item2->GetUsers() - item1->GetUsers(); 
      case 14: //Users desc 
         return item1->GetUsers() - item2->GetUsers(); 
      case 5: //Files asc 
         return item2->GetFiles() - item1->GetFiles(); 
      case 15: //Files desc 
         return item1->GetFiles() - item2->GetFiles(); 
      case 6: //Preferences asc 
         return item2->GetPreferences() - item1->GetPreferences(); 
      case 16: //Preferences desc 
		  return item1->GetPreferences() - item2->GetPreferences(); 
      case 7: //failed asc 
         return item2->GetFailedCount() - item1->GetFailedCount(); 
      case 17: //failed desc 
		  return item1->GetFailedCount() - item2->GetFailedCount(); 
      default: 
         return 0; 
   } 
}